% This is based on the LLNCS.DEM the demonstration file of % the LaTeX macro
% package from Springer-Verlag % for Lecture Notes in Computer Science, version
% 2.4 for LaTeX2e as of 16. April 2010
%
% See http://www.springer.com/computer/lncs/lncs+authors?SGWID=0-40209-0-0-0
% for the full guidelines.
\documentclass{llncs}
\usepackage{graphicx}
\graphicspath{ {./assets/} }

\usepackage{enumitem}
\setlist[enumerate]{itemsep=2mm}

\usepackage{dirtytalk}
\usepackage{minted}
%\usepackage{amsmath}
%\usepackage{mathtools}
\usepackage{amsfonts}
\usepackage{extarrows}
\usepackage{pdflscape}
\usepackage[pass]{geometry}

%
% Tables
% --------
\usepackage[table]{xcolor}
\usepackage{hhline}
\usepackage{booktabs} % much better tables
\usepackage{multirow} % allows to fuse rows
\usepackage{array}    % manipulate array
\usepackage{tabularx} % better tables

% Define new tabularx column types:
%  - R: streteched right aligned
%  - C: stretched centered
%  - N: left aligned, specified space
\newcolumntype{R}{>{\raggedleft\arraybackslash}X}
\newcolumntype{C}{>{\centering\arraybackslash}X}
\newcolumntype{N}[1]{>{\raggedleft\arraybackslash}p{#1}}
\newcolumntype{S}{>{\hsize=.5\hsize}C}

% Set row height multiplicator to provide more breathing space
\renewcommand{\arraystretch}{1.5}

\usepackage[backend=biber]{biblatex}
\addbibresource{bibliography.bib}

\pagestyle{plain}
\setcounter{page}{1}
\pagenumbering{arabic}

%\usepackage{pgfplots}
%\pgfplotsset{width=6cm}
\usepackage{float}
\usepackage[caption = false]{subfig}

\begin{document}

\title{Bitcoin--Monero Cross-chain Atomic Swap}
\author{h4sh3d\inst{1}}

\authorrunning{h4sh3d et al.}
\tocauthor{h4sh3d}
\subtitle{{\normalsize\today{\small\ -- DRAFT}}}
\institute{TrueLevel\\ \email{h4sh3d@truelevel.io}}

\maketitle

\begin{abstract}
    Cross-chain atomic swaps have been discussed for a very long time and are very useful tools. In blockchains where hashed timelock contracts are doable atomic swaps are already deployed, but when one blockchain doesn't have this capability it becomes a challenge. This protocol describes how to achieve atomic swaps between Bitcoin and Monero with two transactions per chain without trusting any central authority, servers, nor the other swap participant.
    We propose a swap between two participants, one holding bitcoin and the other monero, in which when both follow the protocol their funds are not at risk at any moment. The protocol does not require timelocks on Monero side nor script capabilities.
    \keywords{Bitcoin, Monero, atomic swaps}
\end{abstract}

\section{Introduction}
We describe a protocol for an on-chain atomic swap between Monero and Bitcoin, but the protocol can be generalized for Monero and any other cryptocurrencies that fulfill the same requirements as Bitcoin, see \ref{bitcoinPrerequisites}.

This protocol is heavily based on a Monero StackExchange post discussing if it's possible to trade Monero and Bitcoin in a trustless manner \cite{MoneroStackexchangeSwap}. The concept is roughly the same, with changes in Bitcoin construction, less prerequisites in Monero, and more detailed explainations.

Participants send funds into a specific address generated during the process (the lock) on each chain (cross-chain) where each party can take control of the funds on the other chain (swap) only (atomic; i.e. claiming of funds on either chain is mutually exclusive from the ability to claim funds from another chain.)

\subsection{Known limitations}
To provide liveness (if at least one participant is still online) we allow for the worst case scenario in which a participant may end up loosing funds (by not being able to claim on the other chain). This can happen in the case where they do not follow the protocol, e.g. remaining online during pending swap or claiming funds in time. The rationale behind this design is explained in \ref{worstCaseRationale}.

Fees are different from one chain to the other partly because of internal blockchain parameters \& transaction complexity, and also due to external factors such as demand for blockspace. Note that within this protocol the Bitcoin blockchain is used as a decision engine, where we use advanced features of bitcoin, which causes bigger transactions on the bitcoin side. These two factors combined make the Bitcoin transactions more expensive in general than those on the Monero chain.

Instant user feedback in a cross-chain atomic swap is hard to achieve.  The slowest chain and the number of confirmations required by each participant to consider a transaction final, dictates the speed of the protocol, making front runs possible in some setups. But the protocol can be extended to avoid front runs within certain setups. It is worth noting that front runs cannot be enforced to the other participant, thus making the worst case scenario a redund with fee costs on each chain.

\section{Scenario}
We describe the participants and their incentives. Alice, who owns monero (XMR), and Bob, who owns bitcoin (BTC), want to swap funds. We assume that they already have negotiated the price in advance (i.e. amount of bitcoin for amount of monero to swap.) This negotiation can also be integrated into the protocol, for example by swap services who provide a price to their customers.

Both participants wish to only have two possible execution paths (which are mutually exclusive to each other) when executing the protocol: (1) the protocol succeeds and Alice gets bitcoin, Bob gets monero, or (2) the protocol fails and both keep their original funds minus the minimum transaction fees possible.

\subsection{Successful swap}
If both participants follow the protocol there will be four transactions broadcast in total, two on Bitcoin blockchain and two on Monero blockchain. The first ones on each chain lock the funds and makes them ready for the trade on each chain. The second ones unlock the funds for one participant only and gives knowledge to the other participant who takes control of the output on the other chain.

This is the optimal execution of the protocol, requiring no timelocks, the minimum number of transactions and only locking funds for the minimum confirmation on each chain depending on the level of security expected by each participant, i.e. how many confirmations each expects for the funding transaction to be considered final and continue to the next step of the process.

\subsection{Swap correctly aborted}
When locking the bitcoin, after a timelock, Alice or Bob can start the process of refunding the locked funds. At that moment the monero might not be locked yet, if no monero are locked the refund process will just refund the bitcoin, otherwise Alice will learn enough information to refund her monero too.

When the refund transaction is broadcast Bob has to spend the refund before some timelock, otherwise he might end up loosing his bitcoin without getting any monero.  Because of this we can describe this as an interactive protocol from Bob's perspective, i.e. Bob cannot go offline or not react during the swap but Alice can.

\subsection{Worst case scenario}
If the swap is cancelled with the refund process and Bob does not spend his refund before the timelock, Alice can claim the refund without revealing the knowledge needed to Bob to claim on the other chain. Thus one participant, Bob, ends up underwater and three Bitcoin transactions are needed instead of two.

\subsubsection{Rationale}
\label{worstCaseRationale}
This choice is made to avoid the following case: if monero are locked, Alice will be able to refund them only if Bob refunds his bitcoin first. We need an incentive mechanism to force Bob to spend his refund to prevent a deadlock in the refund process or compensate Alice if Bob does not follow the protocol correctly.

\section{Prerequisites}
As previously described, conditional execution must be possible in order to achieve a swap with atomicity. Bitcoin has a small stack-based script language that allows for conditional execution and timelocks. On the other hand, at the moment, Monero with its privacy oriented RingCT design provides only signatures to unlock UTXOs. Meaning that control of UTXOs is only related to who controls the associated private keys. The challenge is then to move control of funds only with knowledge of some private keys.

\subsection{Monero}
Monero does not require any particular primitives on-chain (hashlocks, timelocks), all building blocks are off-chain primitives. Thus we need to provide proofs of the correct initialization of the protocol, which might be the hardest part.

\subsubsection{Secret share,}
to enable a basic two-path execution in Monero. The Monero swap private spend key is split into two secret shares $k^s_a, k^s_b$. Participants will not use any multi-signing protocol, instead, the private spend key shares are distributed during initialization of the swap process where one participant will gain knowledge of the full key $k^s \equiv k^s_a + k^s_b \pmod l$ at the end of the protocol execution, either for a completed swap or for an aborted swap.

\subsubsection{Pre-image non-interactive zero-knowledge proof of knowledge}
proves to the other participant that a valid pre-image $\alpha$ to a given hash $h = \mathcal{H}(\alpha)$ is known and within a specific range, e.g. $\alpha \in [1, l-1]$ where $l$ is related to \texttt{edward25519} curve and $\mathcal{H}$ is the \texttt{SHA256} algorithm. The scalar $\alpha$ must be serialized in a standard way.

\subsubsection{\texttt{Edward25519} private key non-interactive zero-knowledge proof of knowledge}
proves to the other participant that a valid private key $x$ on \texttt{edward25519} is known for a given public key $X$, e.g. signatures are non-interactive zero-knowledge proof of knowledge given some public keys.

\subsection{Bitcoin}
\label{bitcoinPrerequisites}
The bitcoin transactions in this protocol require \texttt{SegWit} activation in order to be able to chain unbroadcast transactions. These requirements must be fulfilled for any other cryptocurrencies with a bitcoin style UTXO model [such as Litecoin] which wish to compatible with this protocol (i.e. Bitcoin Cash is not compatible.)

\subsubsection{Timelock,}
to enable new execution paths after some predefined amount of time, e.g. start the refund process after having locked funds on-chain without creating a race condition. It is worth noting that we do not require timelocks for Monero.

\subsubsection{Hashlock,}
to reveal secrets to the other participant. Hashlocks are primitives that require one to reveal some data (a pre-image) associated with a given hash to be allowed to spend the associated UTXO.

\subsubsection{2-out-of-2 multisig,}
to create a common path accessible only by the two participants if both agree. In this protocol we use the on-chain option  but off-chain multi-signature scheme can replace it.

\subsection{Curves parameters}
\label{curveParams}
Bitcoin and Monero does not use the same elliptic curves. Bitcoin uses the \texttt{secp256k1} curve from \textit{Standards for Efficient Cryptography (SEC)} with the \texttt{ECDSA} algorithm while Monero, based on the second version of CryptoNote \cite{van2013cryptonote}, uses \texttt{Curve25519}, hereinafter also \texttt{edward25519}, from Daniel J. Bernstein \cite{CerRes10}.

We denote curve parameters for

\subsubsection{\texttt{edward25519}} as
\begin{equation}
\begin{split}
    q&: \text{a prime number;}\ q = 2^{255} - 19 \\
    d&: \text{an element of } \mathbb{F}_q;\ d = - 121665/121666 \\
    E&: \text{an elliptic curve equation};\ -x^2 + y^2 = 1 + dx^2y^2 \\
    G&: \text{a base point};\ G = (x, -4/5) \\
    l&: \text{the base point order};\ l = 2^{252} + \text{\scriptsize27742317777372353535851937790883648493} \\
\end{split}
\end{equation}

\subsubsection{\texttt{secp256k1}} as
\begin{equation}
\begin{split}
    p&: \text{a prime number;}\ p = 2^{256} - 2^{32} - 2^9 - 2^8 - 2^7 - 2^6 - 2^4 - 1 \\
    a&: \text{an element of } \mathbb{F}_p;\ a = 0 \\
    b&: \text{an element of } \mathbb{F}_p;\ b = 7 \\
    E'&: \text{an elliptic curve equation};\ y^2 = x^3 + bx + a \\
    G'&: \text{a base point};\ G' = \\ (&\texttt{\scriptsize0x79BE667EF9DCBBAC55A06295CE870B07029BFCDB2DCE28D959F2815B16F81798},\\ &\texttt{\scriptsize0x483ADA7726A3C4655DA4FBFC0E1108A8FD17B448A68554199C47D08FFB10D4B8}) \\
\end{split}
\end{equation}

\section{Protocol}
%In this chapter we describe the protocol for Alice and Bob to swap their funds atomically and without trusting each other.

The overall protocol is as follows: Alice moves the monero into an address where each participant controls half of the private spend key. The Bitcoin scripting language is then used to reveal one of the halfs of the private spend key depending on which participant claims the bitcoin. Depending on who reveals the key share, the locked monero changes ownership. Bitcoin transactions are designed in such a way that if a participant follows the protocol he can't terminate with a loss.

If the deal goes through, Alice spends the bitcoin by revealing her private key share, thus allowing Bob to spend the locked monero. If the deal is cancelled, Bob spends the bitcoin after the first timelock by revealing his private key share thus allowing Alice to spend the monero, in both cases minus transaction fees.

The full protocol is shown in Figure \ref{fig:protocol}.

\subsection{Zero-Knowledge proofs}
Zero-knowledge proofs are required at the beginning of the protocol for trustlessness. The protocol uses hashes as commitments of private keys, but we cannot check the hash of the other participant before it goes on-chain. Thus we need to provide a proof that the hash used in the Bitcoin script is the serialized private share and not other random data.
%Two zero-knowledge proofs are required at the beginning of the protocol for trustlessness. They are quite symmetric but Bob needs to prove an extra piece of information to Alice. We denote Alice's ZKP basic ZKP and Bob's one extended ZKP.

\subsubsection{ZKP}
Alice and Bob must prove to each other with $i \in \{a, b\}$
\begin{equation}
\begin{split}
    k^s_i &\leftarrow \text{valid scalar on \texttt{edward25519} curve} \\
    K^s_i &= k^s_iG \\
    h_i &= \mathcal{H}(k^s_i) \text{ for $\mathcal{H}$ as \texttt{SHA256}} \\
\end{split}
\end{equation}

that given $K^s_i$ and $h_i$
\begin{equation}
\begin{split}
    \exists k^s_i \mid K^s_i = k^s_iG \land h_i = \mathcal{H}(k^s_i) \land k^s_i \in [1, l-1]
\end{split}
\end{equation}
where $\mathcal{H}(k^s_i)$ is the hash of the 256-bit little-endian integer representation of $k^s_i$.

\begin{figure}[H]
    \begin{table}[H]
        \centering
      {\renewcommand{\arraystretch}{1.1}%
      \begin{tabular}{ | l c l | }
        \hline
          \multicolumn{1}{|c}{Alice (XMR$\rightarrow$BTC)} &  & \multicolumn{1}{c|}{Bob (BTC$\rightarrow$XMR)} \\
          & \textit{Initialization phase} & \\
          $k^v_a, k^s_a \xleftarrow{R} [1, l-1]$ & & $k^v_b, k^s_b \xleftarrow{R} [1, l-1]$ \\
          $K^s_a \leftarrow k^s_aG$ & & $K^s_b \leftarrow k^s_bG$ \\
          $b_a \xleftarrow{R} [1, p-1]$ & & $b_b \xleftarrow{R} [1, p-1]$ \\
          $B_a \leftarrow b_aG'$ & & $B_b \leftarrow b_bG'$ \\
          $h_a \leftarrow \mathcal{H}(k^s_a)$ & & $h_b \leftarrow \mathcal{H}(k^s_b)$ \\
          & & $s \xleftarrow{R} \mathbb{Z}_{2^{256}}$ \\
          & & $h_s \leftarrow \mathcal{H}(s)$ \\
          $z_a \leftarrow \texttt{zkp}(k^s_a)$ & & $z_b \leftarrow \texttt{zkp}(k^s_b)$ \\
           & & \\
          \multicolumn{3}{|c|}{$\xlongleftrightarrow{\langle k^v_a, k^v_b, K^s_a, K^s_b, B_a, B_b, h_a, h_b, h_s, z_a, z_b \rangle}$} \\
          verify $[k^v_b, K^s_b, B_b, z_b]$ & & verify $[k^v_a, K^s_a, B_a, z_a]$ \\
          & $k^v \equiv k^v_a + k^v_b \pmod l$ & \\
          & $K^v = k^vG$ & \\
          & $K^s = K^s_a + K^s_b$ & \\
          & \textit{Lock phase} & create $[\text{BTX}_\textit{lock}$, $\text{BTX}_\textit{refund}]$ \\
          & & sign $\text{BTX}_\textit{refund}$ \\
          \multicolumn{3}{|c|}{$\xleftarrow{\langle \text{BTX}_\textit{lock}, \text{BTX}_\textit{refund} \rangle}$} \\
          verify $[\text{BTX}_\textit{lock}$, $\text{BTX}_\textit{refund}]$ & & \\
          sign $\text{BTX}_\textit{refund}$ & & \\
          \multicolumn{3}{|c|}{$\xrightarrow{\langle \text{BTX}_\textit{refund}^\textit{signed} \rangle}$} \\
          & & verify $\text{BTX}_\textit{refund}^\textit{signed}$ \\
          & & sign $\text{BTX}_\textit{lock}$ \\
          & & broadcast $\text{BTX}_\textit{lock}^\textit{signed}$ \\
          \multicolumn{3}{|c|}{$\xleftarrow{(\text{watch BTX}_\textit{lock})}$} \\
          create $\text{XTX}_\textit{lock}$ w/ $(K^v, K^s)$ & & \\
          sign $\text{XTX}_\textit{lock}$ & & \\
          broadcast $\text{XTX}_\textit{lock}^\textit{signed}$ & & \\
          \multicolumn{3}{|c|}{$\xrightarrow{(\text{watch w/ } (k^v, K^s))}$} \\
          & \textit{Swap phase} & verify $(K^v, K^s)$ w/ $(k^v, K^s)$ \\
          \multicolumn{3}{|c|}{$\xleftarrow{\langle s \rangle}$} \\
          spend $\text{BTX}_\textit{lock}$ w/ $\langle k^s_a, b_a, s \rangle$ & & \\
          \multicolumn{3}{|c|}{$\xrightarrow{\text{watch BTX}_\textit{lock}}$} \\
          & & $k^s \equiv k^s_a + k^s_b \pmod l$ \\
          & & spend $\text{XTX}_\textit{lock}$ w/ $\langle k^v, k^s \rangle$ \\
        \hline
      \end{tabular}}
    \end{table}
  \caption{Full protocol of cross-chain atomic swap for Bitcoin--Monero between two participants Alice and Bob with initialization, lock, and swap phases.}
  \label{fig:protocol}
\end{figure}

\subsection{Time parameters}
Two timelocks $t_0, t_1$ are defined during the initialization phase. $t_0$ sets the time window during which it is safe to execute the trade, after $t_0$ the refund process may start, making the trade unsafe to complete because of a potential race condition (even if hard to exploit in reallity). $t_1$ sets the response time during which Bob is required to react and reveal his private Monero share to get his bitcoin back and allow Alice to redeem her monero (if monero have been locked).

\subsection{Monero private keys}
Monero private keys are pairs of \texttt{edward25519} scalars. The first scalar is called private view key and the second is called private spend key. We use small letters to denote private keys and cappital letters for public keys such that
$$X = xG$$
Where $G$ is the generator element of the curve (see \ref{curveParams}). We denote
\begin{enumerate}[label=(\roman*)]
    \item the private key $k^v$ as the full private view key,
    \item $K^v$ as the full public view key,
    \item $k^v_a$ as the private view key share of Alice and $k^v_b$ of Bob,
    \item the private key $k^s$ as the full private spend key,
    \item $K^s$ as the full public spend key,
    \item and $k^s_a$ as the private spend key share of Alice and $k^s_b$ of Bob.
\end{enumerate}

\subsubsection{Partial keys}
We denote private key shares as $k^s_a$ and $k^s_b$ such that
$$k^s_a + k^s_b \equiv k^s \pmod l$$

And then
\begin{equation}
\begin{split}
    k^s_aG &= K^s_a \\
    k^s_bG &= K^s_b \\
    K^s_a + K^s_b = (k^s_a + k^s_b)G = k^sG &= K^s
\end{split}
\end{equation}

The same holds for $k^v$ with $k^v_a$ and $k^v_b$.

\subsection{Bitcoin scripts}

\subsubsection{\texttt{SWAPLOCK}}
is a \texttt{P2SH} used to lock funds and defines the two base execution paths: (1) swap execution [success] and (2) refund execution [fail]. We define the \texttt{SWAPLOCK} script as:

\begin{minted}[escapeinside=||,mathescape=true]{text}
OP_IF
    OP_SHA256 <|$h_a$|> OP_EQUALVERIFY
    OP_SHA256 <|$h_s$|> OP_EQUALVERIFY
    <|$B_a$|> OP_CHECKSIG
OP_ESLE
    <|$t_0$|> OP_CHECKSEQUENCEVERIFY OP_DROP
    2 <|$B_a$|> <|$B_b$|> 2 OP_CHECKMULTISIG
OP_ENDIF
\end{minted}

\subsubsection{Buy \texttt{SWAPLOCK},}
Alice takes control of bitcoin and reveals her Monero key share, thus allowing Bob to take control of the monero. Alice can redeem the \texttt{SWAPLOCK} with:

\begin{minted}[escapeinside=||,mathescape=true]{text}
<|$sig_a$|> <|$s$|> <|$k^s_a$|> OP_TRUE <|\texttt{SWAPLOCK} script|>
\end{minted}

\subsubsection{Refund \texttt{SWAPLOCK},}
signed by both participants and moves the funds into \texttt{REFUND P2SH}. $\text{BTX}_\textit{refund}$ uses the following redeem script:

\begin{minted}[escapeinside=||,mathescape=true]{text}
OP_0 <|$sig_a$|> <|$sig_b$|> OP_FALSE <|\texttt{SWAPLOCK} script|>
\end{minted}

\subsubsection{\texttt{REFUND}}
is a \texttt{P2SH} used in case the swap already started on-chain but is cancelled. This refund script is used to lock the only output of the transaction which spends the \texttt{SWAPLOCK} output with the 2-out-of-2 timelocked multisig. We define the \texttt{REFUND} script as:

\begin{minted}[escapeinside=||,mathescape=true]{text}
OP_IF
    OP_SHA256 <|$h_b$|> OP_EQUALVERIFY
    <|$B_b$|> OP_CHECKSIG
OP_ESLE
    <|$t_1$|> OP_CHECKSEQUENCEVERIFY OP_DROP
    <|$B_a$|> OP_CHECKSIG
OP_ENDIF
\end{minted}

\subsubsection{Spend \texttt{REFUND},}
Bob cancels the swap and reveals his Monero private share in order to redeem the \texttt{REFUND P2SH}, thus allowing Alice to regain control over her Monero. Bob can redeem it with:

\begin{minted}[escapeinside=||,mathescape=true]{text}
<|$sig_b$|> <|$k^s_b$|> OP_TRUE <|\texttt{REFUND} script|>
\end{minted}

\subsubsection{Claim \texttt{REFUND},}
Alice takes control of bitcoin after both timelocks without revealing her Monero key share, ending up with Bob loosing money for not following the protocol. Alice can redeem the \texttt{REFUND P2SH} with:

\begin{minted}[escapeinside=||,mathescape=true]{text}
<|$sig_a$|> OP_FALSE <|\texttt{REFUND} script|>
\end{minted}

\subsection{Transactions}
\subsubsection{$\text{BTX}_\textit{lock}$,}
Bitcoin transaction with $\geq 1$ inputs from Bob and the first output (vout: 0) to \texttt{SWAPLOCK P2SH} and optional change outputs.

\subsubsection{$\text{BTX}_\textit{refund}$,}
Bitcoin transaction with 1 input consuming \texttt{SWAPLOCK P2SH} ($\text{BTX}_\textit{lock}$, vout: 0) with the 2-out-of-2 timelocked multisig and exactly one output to \texttt{REFUND P2SH} script.

\subsubsection{$\text{XTX}_\textit{lock}$,}
Monero transaction that sends funds to the address $(K^v,K^s)$.

\section{Acknowledgement} Daniel Lebrecht and Tom Shababi are acknowledged for their helpful contribution and comments during the completion of this work.

%
% ---- Bibliography ----
%
\printbibliography

\end{document}
